diff -urN BitchX-clean/source/cfunctions.c BitchXcns-1.0c19cns/source/cfunctions.c
--- BitchX-clean/source/cfunctions.c	Thu Jan  1 01:00:00 1970
+++ BitchXcns-1.0c19cns/source/cfunctions.c	Fri Apr  5 14:49:43 2002
@@ -0,0 +1,2034 @@
+/*
+ * Specific CNSirc functions
+ *
+ *
+ */
+#include <stdio.h>
+#include <stdarg.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <fcntl.h>
+
+#include "irc.h"
+#include "struct.h"              
+#include "commands.h"
+#include "output.h"
+#include "window.h"
+#include "ctcp.h"
+#include "color.h"
+#include "misc.h"
+#include "cset.h"
+#include "status.h"
+#include "vars.h"
+#include "server.h"
+#include "modval.h"
+
+#include "cfunctions.h"
+
+#define L_BIG_BUFFER_SIZE 255 * BIG_BUFFER_SIZE
+#define RSA_CRLEN 128
+
+RSA *my_priv_key = NULL;
+
+static char codec[] = { // codec has 64 elements.
+  'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l',
+  'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 
+  'y', 'z', 
+  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L',
+  'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
+  'Y', 'Z',
+  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
+  '+', '/'
+};
+
+struct st_nick_crypted *nick_head = NULL;
+struct st_chan_crypted *chan_head = NULL;
+
+char *last_chan = NULL;
+char *last_nick = NULL;
+
+int get_from_codec(char a)
+{   
+	int i;
+	for (i = 0; i < 64; i ++)
+		if (codec[i] == a)
+			return i;
+
+	return -1;
+}
+
+unsigned long my_cksum (unsigned char *buf, int len) 
+{
+	unsigned long sum;
+
+	for (sum = 0, len -= 4; len >= 0; len -= 4)
+	{
+		sum += *(long*)(buf + len);
+		sum = ~sum;
+	}
+	return sum;
+}
+
+void c_say (char *display, const char *format, ...)
+{
+	if (format && window_display && get_int_var(SHOW_ALL_CNSIRC_MESSAGES_VAR))
+	{
+		int len;
+		va_list args;
+		u_char *buf_out = new_malloc(L_BIG_BUFFER_SIZE);
+		set_display_target(display, LOG_CURRENT);
+		va_start(args, format);
+		sprintf(buf_out, "[*] ");
+		len = strlen(buf_out);
+		vsnprintf(&(buf_out[len]), L_BIG_BUFFER_SIZE, format, args);
+		va_end(args);
+		if (strip_ansi_in_echo)
+		{
+			register char *ptr;
+			for (ptr = buf_out+len; *ptr; ptr++)
+				if (*ptr < 31 && *ptr > 13)
+					if (*ptr != 15 && *ptr != 22)
+						*ptr = (*ptr & 127) | 64;
+		}
+		put_echo(buf_out);
+		new_free(&buf_out);
+	}
+}
+
+/*
+ * prend en parametre la clé RSA et renvoit une chaine 'lisible' pour l'irc
+ */
+char *encode_rsa_key (unsigned char *rsapubkey)
+{
+	char l[256], *finale;
+	unsigned char intermed[129];
+	u_char a, b, c;
+	int x, y, w, z, n;
+	int i; 
+
+	int len_before = strlen(rsapubkey);
+
+	bzero(intermed, 129);
+
+	for (i = 0; i < len_before; i += 2)
+	{
+		l[i] = 0;
+		a = (rsapubkey[i]>=65)?rsapubkey[i]-55:rsapubkey[i]-48;
+		b = (rsapubkey[i + 1]>=65)?rsapubkey[i + 1]-55:rsapubkey[i + 1]-48;
+		c = a; c *= 16; c += b;
+		intermed[i/2] = c;
+	}
+
+	finale = new_malloc(sizeof(char) * len_before);
+	bzero(finale, len_before);
+
+	for (n = 0, i = 0; i < (len_before / 2); i += 3)
+	{
+		w = intermed[i] >> 2;
+		x = ((intermed[i + 1]) >> 4) + ((intermed[i] % 4) << 4);
+		y = ((intermed[i + 1] % 16) << 2) + ((intermed[i + 2]) >> 6);
+		z = intermed[i + 2] % 64;
+		finale[n] =     codec[intermed[i] >> 2];
+		finale[n + 1] = codec[x];
+		finale[n + 2] = codec[y];
+		finale[n + 3] = codec[intermed[i + 2] % 64];
+
+		n += 4;
+	}
+
+	return (finale);
+}
+
+char *decode_rsa_key (unsigned char *rsapubkey)
+{
+	unsigned char *decode;
+	int i, n, j;
+	unsigned char a, b, c, d;
+	unsigned char x, y, z;
+
+	decode = new_malloc(512);
+
+	for (n = 0, i = 0; i < 256; i += 4)
+	{
+
+		a = get_from_codec(rsapubkey[i]);
+		b = get_from_codec(rsapubkey[i + 1]);
+		c = get_from_codec(rsapubkey[i + 2]);
+		d = get_from_codec(rsapubkey[i + 3]);
+
+		x = (a << 2) + (b >> 4);
+		y = (b << 4) + (c >> 2);
+		z = d + (c << 6);
+
+		decode[n] = x >> 4;
+		decode[n + 1] = x % 0x10;
+
+		decode[n + 2] = y >> 4;
+		decode[n + 3] = y % 0x10;
+
+		decode[n + 4] = z >> 4;
+		decode[n + 5] = z % 0x10;
+
+		for (j = 0; j < 6; j ++)
+		{
+			if (decode[j + n] < 10) decode[j + n] += 48;
+			else decode[j + n] += 55;
+		}
+
+		n += 6;
+	}
+
+	decode[256] = 0;
+	return(decode);
+}
+
+/*
+ * renvoit une chaine de caractère de 32 octets.
+ */
+unsigned char *cns_generate_channel_key()
+{
+	unsigned char *key;
+
+	key = new_malloc(sizeof(char) * 32);
+	RAND_pseudo_bytes(key, 32);
+	return(key);
+}
+
+/*
+ * génère une clée puis les assigne.
+ */
+void cmd_generate_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	RSA *local_priv;
+//	RSA *local_pub;
+	c_say(NULL, "Generating my own new RSA keys ... please wait.");
+
+	local_priv = RSA_generate_key(1024, 65537, NULL, NULL);	
+	if (local_priv == NULL) { c_say(NULL, "Error generating keys."); return; }
+
+//	local_pub = RSA_new();
+//	if (local_pub == NULL) { c_say(NULL, "Error allocating new key"); return; }
+//	local_pub->n = BN_dup(local_priv->n);
+//	local_pub->e = BN_dup(local_priv->e);
+
+	c_say(NULL, "Creating a new RSA key is ok.");
+
+	if (my_priv_key)
+	{
+		c_say(NULL, "You've already got a key. I won't delete it until you use /freemykey.");
+	} 
+	else 
+	{
+		RSA_free(my_priv_key);
+		my_priv_key = local_priv;
+		c_say(NULL, "New key is operationnal.");
+	}
+}
+
+/*
+ * libere ma clée
+ */
+void cmd_free_my_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	if (my_priv_key)
+	{
+		c_say(NULL, "Now freeing your actual key.");
+		RSA_free(my_priv_key);
+		my_priv_key = NULL;
+	}
+	else
+	{
+		c_say(NULL, "Your key is already cleaned.");
+	}
+}
+
+/*
+ * charge la clée à partir d'un fichier
+ */ 
+void cmd_load_my_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char filename[1024];
+	BIO *in = NULL;
+
+	last_chan = NULL;
+	last_nick = NULL;
+
+	if (my_priv_key)
+	{
+		c_say(NULL, "You've already got a key. I won't delete it until you use /freemykey.");
+		return;
+	}
+
+	in = BIO_new(BIO_s_file());
+	if (in == NULL)
+	{
+		c_say(NULL, "SSL IO error. Can't open a IO channel.");
+		return;
+	}
+
+	sprintf(filename, "%s/.BitchX/CNSkeys/CNSirc.key", getenv("HOME"));
+
+	if (BIO_read_filename(in, filename) <= 0)
+	{
+		c_say(NULL, "Can't open or read your key file. Please check access or generate new.");
+		BIO_free(in);
+		return;
+	}
+
+	my_priv_key = PEM_read_bio_RSAPrivateKey(in, NULL, NULL,NULL);
+	if (!my_priv_key)
+	{
+		c_say(NULL, "Problem reading your RSA key. You should generate a new.");
+		BIO_free(in);
+		return;
+	}
+
+	BIO_free(in);
+	c_say(NULL, "Key file is loaded.");
+}
+
+/*
+ * Sauve les clés dans un fichier.
+ */
+void cmd_save_my_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char filename[1024];
+	BIO *out=NULL;
+
+	if (!my_priv_key)
+	{
+		c_say(NULL, "No keys to save.");
+		return;
+	}
+
+	sprintf(filename, "%s/.BitchX/", getenv("HOME"));
+	if (access(filename, R_OK | W_OK | X_OK) == -1)
+	{
+		c_say(NULL, "Can't access on %s", filename);
+		return;
+	}
+	else
+	{
+		sprintf(filename, "%s/.BitchX/CNSkeys/", getenv("HOME"));
+		if (access(filename, F_OK) == -1)
+		{
+			mkdir (filename, 0700);
+		}
+
+		if (access(filename, R_OK | W_OK | X_OK) == -1)
+		{
+			c_say(NULL, "Can't access on %s", filename);
+			return;
+		}
+	}
+ 
+	if ((out = BIO_new(BIO_s_file())) == NULL)
+	{
+		c_say(NULL, "Problem opening a BIO output.");
+		return;
+	}
+
+	sprintf(filename, "%s/.BitchX/CNSkeys/CNSirc.key", getenv("HOME"));
+
+	if (BIO_write_filename(out, filename) <= 0)
+	{
+		c_say(NULL, "Hmm problems creating CNSirc.key file.");
+		BIO_free_all(out);
+		return;
+	}
+
+	if (!PEM_write_bio_RSAPrivateKey(out, my_priv_key, NULL, NULL, 0, NULL, NULL))
+	{
+		c_say(NULL, "Can't fill key file (%s)");
+		BIO_free_all(out);
+		return;
+	}
+
+	BIO_free_all(out);
+    if (chmod(filename, 0600))
+      c_say (NULL, "Problems chmod'ing CNSirc.key. DO CHMOD 600 yourself !");
+
+	c_say(NULL, "Saving keys is ok.");
+}
+
+void cmd_test_my_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char test_chaine[128];
+	char chiffree[128], dechiffree[128];
+	RSA *temp_pub_key;
+	int r;
+
+	if (!my_priv_key)
+	{
+		c_say(NULL, "No key to test.");
+		return;
+	} 
+
+	temp_pub_key = RSA_new();
+	temp_pub_key->n = BN_dup(my_priv_key->n);
+	temp_pub_key->e = BN_dup(my_priv_key->e);
+
+	bzero(test_chaine, 128);
+	strcpy(test_chaine, "allalalzlelzleazlmerermezr");
+
+	c_say(NULL, "Testing: Injecting: %i", strlen(test_chaine));
+
+	r = RSA_public_encrypt(strlen(test_chaine), test_chaine, chiffree, temp_pub_key, RSA_PKCS1_PADDING);
+	c_say(NULL, "RSA_public_encrypt: %i", r);
+
+	r = RSA_private_decrypt(r, chiffree, dechiffree, my_priv_key, RSA_PKCS1_PADDING);
+	c_say(NULL, "RSA_private_decrypt: %i", r);
+
+	RSA_free(temp_pub_key);
+}
+
+void cmd_key_info (char *cmd, char *args, char *subargs, char *helparg)
+{
+	RSA *temp_pub_key;
+	unsigned char *pubkey, *privkey1, *privkey2;
+	unsigned long crc32, crc321;
+
+	if (!my_priv_key)
+	{
+		c_say(NULL, "No key to give info. Use /genmykey.");
+		return;
+	}
+
+	temp_pub_key = RSA_new();
+	temp_pub_key->n = BN_dup(my_priv_key->n);
+	temp_pub_key->e = BN_dup(my_priv_key->e);
+
+	pubkey = BN_bn2hex(temp_pub_key->n);
+	privkey1= BN_bn2hex(my_priv_key->q);
+	privkey2= BN_bn2hex(my_priv_key->p);
+
+	if (!pubkey)
+	{
+		c_say(NULL, "Hum ... OpenSSL error (cmd_key_info; BN_bn2hex).");
+		return;
+	}
+	
+	if (strlen(pubkey) <= 0)
+	{
+		c_say(NULL, "Hum ... Is it an error ? strlen(pubkey) returned %i", strlen(pubkey)); 
+		return;
+	}
+
+	crc32 = my_cksum(pubkey, strlen(pubkey));
+	c_say(NULL, "Public Key:  %.8X (len: %i)", crc32, strlen(pubkey));
+
+	crc32 = my_cksum(privkey1, strlen(privkey1));
+	crc321 = my_cksum(privkey2, strlen(privkey2));
+ 
+	c_say(NULL, "Private Key: %.8X, %.8X (len: %i)", crc32, crc321, 
+		strlen(privkey1) + strlen(privkey2));
+
+	RSA_free(temp_pub_key);
+}
+
+void cmd_version (char *cmd, char *args, char *subargs, char *helparg)
+{
+	c_say(NULL, "%s (internal version: %s) by CNS/Minithins %s", irc_version, internal_version, CNS_VERSION);
+}
+
+/**** twofish3.c crypto functions ****/
+
+void cmd_test_twofish (char *cmd, char *args, char *subargs, char *helparg)
+{
+	unsigned char data[16];
+	unsigned char *key;
+	unsigned char crypted[16], uncrypted[16];
+
+	key = cns_generate_channel_key();
+
+	set_key_twofish((const u4byte*)key, 256);
+
+	strncpy(data, "lalatestlililul\0", 16);
+
+	encrypt_twofish ((const u4byte*)data, (u4byte*)crypted);	
+
+	decrypt_twofish ((const u4byte*)crypted, (u4byte*)uncrypted);
+
+	if (!strncmp(data, uncrypted, 16))
+		c_say(NULL, "Twofish encryption seems to be ok");
+	else
+	{
+		c_say(NULL, "Twofish encryption error");
+		c_say(NULL, "Before: [%s]", data);
+		c_say(NULL, "After : [%s]", uncrypted);
+	}
+
+	new_free(&key);
+
+}
+
+void cmd_send_pubkey (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *target, *text, *inte, *temptext;
+	unsigned long crc;
+
+	if ((target = next_arg(args, &args)) == NULL)
+		target = get_target_by_refnum(0);
+
+	text = new_malloc(512);
+
+	if (target)
+	{
+		if (!my_priv_key)
+		{
+			c_say(target, "No key found. Use /genmykey");
+		}
+		else
+		{
+			temptext = BN_bn2hex(my_priv_key->n);
+			if ((inte = encode_rsa_key(temptext)) != NULL)
+			{
+				crc = my_cksum(inte, strlen(inte));
+				sprintf(text, "<CNSirc>%s %.8x", inte, (unsigned int)crc); 
+				if (get_int_var(SHOW_RSA_KEY_VAR))
+				{
+					send_text(target, text, NULL, window_display, 1);
+				}
+				else
+				{
+					send_to_server("PRIVMSG %s :%s", target, text);	
+					c_say(target, "Send your RSA key to %s", target);
+				}
+				new_free(&inte);
+			}
+			else
+			{
+				c_say(target, "Memory error ?!");
+			}
+		}
+	}
+	else
+	{
+		c_say(NULL, "You're not on a channel");
+	}
+	
+	new_free(&text);
+}
+
+int check_is_rsa_key (char *ptr)
+{
+	if (strlen(ptr) == 189)	
+		if (!strncmp("<CNSirc>", ptr, 8))
+			return 1;
+
+	return 0;
+}
+
+void get_rsa_key (char *from, char *to, char *ptr)
+{
+	unsigned char *pubrsakey, *texte, *chksum;
+	unsigned char *temp_var;
+
+	texte = new_malloc(172);
+	bzero (texte, 172);
+	chksum = new_malloc(8);
+	temp_var = new_malloc(8);
+
+	if (sscanf(ptr, "<CNSirc>%s %s", texte, chksum) != 2)
+	{
+		c_say(from, "not enough args ?");
+		new_free(&texte); new_free(&chksum);
+		new_free(&temp_var);
+		return ;
+	}
+	
+	sprintf(temp_var, "%.8x", (int)my_cksum(texte, 172)); 
+
+	if (strcmp(temp_var, chksum))
+	{
+		c_say(from, "I got a faked key with a wrong checksum.");
+		new_free(&texte); new_free(&chksum);
+		new_free(&temp_var);
+		return;
+	}
+
+//	c_say("[%s][%s]", texte, chksum);
+
+	pubrsakey = decode_rsa_key(texte);
+
+	new_free(&texte); new_free(&chksum); new_free(&temp_var);
+
+	if (!pubrsakey)
+	{
+		c_say(from, "Error while getting a public rsa key.");
+		return ;
+	}
+
+	if (strlen(pubrsakey) != 256)
+	{
+		c_say(from, "Incompatible rsa key lenght: %i", strlen(pubrsakey));
+		return ;
+	}
+
+	/*
+	 * I don't care of "from", i keep pubrsakey (malloced by decode)
+	 * for my structure.
+	 */
+	add_rsa_key(from, pubrsakey);
+
+	if (last_nick) new_free(&last_nick);
+	last_nick = new_malloc(strlen(from));
+	strcpy(last_nick, from);
+
+//	if (last_chan) new_free(&last_chan);
+//	last_chan = new_malloc(strlen(to));
+//	strcpy(last_chan, to);
+
+	if (get_pass_from_chan(to))
+	{
+		if (last_chan) new_free(&last_chan);
+		last_chan = new_malloc(strlen(to));
+		strcpy(last_chan, to);
+	}
+
+	return ;
+}
+
+/*
+ * find a key from a nick and return it.
+ */
+/*
+    struct st_a_nick
+    {
+        struct st_a_nick *next;
+        char             *nick;
+    };
+ */
+RSA *get_rsa_key_from_nick (char *nick)
+{
+	struct st_nick_crypted *temp;
+	struct st_a_nick *temp_nick;
+	
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick; 
+			temp_nick = temp_nick->next)
+			if (!strcasecmp(nick, temp_nick->nick))
+				return temp->hispubkey;
+	}
+	return NULL;
+} 
+
+int is_trusted_nick (char *nick)
+{
+	struct st_nick_crypted *temp;
+	struct st_a_nick *temp_nick;
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			if (!strcmp(nick, temp_nick->nick))
+			{
+				if (temp->opt & 1)
+					return 1;
+				else
+					return 0;
+			}
+	}
+
+	return 0;
+}
+
+/*
+ * adds a key in the list
+ */
+void add_rsa_key (char *nick, unsigned char *pubkey)
+{
+	RSA *temp_key;
+	unsigned char *o_pubkey;
+	struct st_nick_crypted *temp;
+	struct st_a_nick       *temp_nick;
+	unsigned long crc32, o_crc32;
+
+	if (get_rsa_key_from_nick(nick))
+	{ // you have to update
+		for (temp = nick_head; temp; temp = temp->next)
+		{
+			for (temp_nick = temp->nick_list; temp_nick;
+				temp_nick = temp_nick->next)	
+				if (!strcmp(nick, temp_nick->nick))
+					break;
+
+			if (temp_nick)
+				if (!strcmp(nick, temp_nick->nick))
+					break;
+		}
+
+		if (temp)
+		{
+			o_pubkey = BN_bn2hex(temp->hispubkey->n);
+			o_crc32 = my_cksum (o_pubkey, strlen(o_pubkey));
+
+			if (!strcmp(o_pubkey, pubkey))
+			{
+				c_say(nick, "Recieved %s's public key (same key as the older)",
+					nick);
+			}
+			else
+			{
+				RSA_free(temp->hispubkey);
+				temp->hispubkey = RSA_new();
+				BN_hex2bn(&(temp->hispubkey->n), pubkey);
+				BN_hex2bn(&(temp->hispubkey->e), "10001");
+
+				crc32 = my_cksum(pubkey, strlen(pubkey));
+				c_say(nick, "Updated %s's public key (crc is %.8X and was %.8X)", nick, crc32, o_crc32);
+				if (temp->opt & 1)
+				{
+					temp->opt --;
+					c_say("%s's key no longer trusted (reason: changed)", nick);
+				}
+			}
+		}
+	}
+	else
+	{
+
+		// i've to see if i've already the key
+		//
+
+		temp_key = RSA_new ();
+		BN_hex2bn(&(temp_key->n), pubkey);
+
+		for (temp = nick_head; temp; temp = temp->next)
+			if (!BN_cmp(temp_key->n, temp->hispubkey->n))
+				break;
+
+		if (!temp)
+		{
+			temp = new_malloc(sizeof(struct st_nick_crypted));
+			temp->next = nick_head;
+			nick_head = temp;
+
+			temp->hispubkey = RSA_new();
+			BN_hex2bn(&(temp->hispubkey->n), pubkey);
+			BN_hex2bn(&(temp->hispubkey->e), "10001");
+			temp->opt = 0;
+
+			temp->nick_list = new_malloc(sizeof(struct st_a_nick));
+			temp->nick_list->next = NULL;
+			temp->nick_list->nick = new_malloc(32);
+			strncpy(temp->nick_list->nick, nick, (strlen(nick)>32)?32:strlen(nick));
+	
+			temp->crypt_typ = RSA_CRYPT;
+
+			crc32 = my_cksum(pubkey, strlen(pubkey));
+			c_say(nick, "Got %s's public key (crc is %.8X, len is %i)", 
+				nick, crc32, strlen(pubkey));
+		}
+		else
+		{
+			c_rename_nick (temp->nick_list->nick, nick);
+			crc32 = my_cksum(pubkey, strlen(pubkey));
+			c_say(nick, "Added %s to %s's nick list (crc is %.8X, len is %i)", 
+				nick, temp->nick_list->next->nick, crc32, strlen(pubkey));
+		}
+	}
+}
+
+void clear_nick (char *nick)
+{
+	struct st_nick_crypted *temp;
+	struct st_a_nick       *temp_nick, *old_temp_nick = NULL;
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			if (!strcmp(temp_nick->nick, nick))
+				break;
+
+		if (temp_nick)
+			if (!strcmp(temp_nick->nick, nick))
+				break;
+	}
+
+	if (!temp || !temp_nick)
+	{
+		c_say(nick, "Can't find %s ...", nick);
+		return;
+	}
+
+	if (temp->nick_list == temp_nick && temp_nick->next == NULL)
+	{
+		// no more nicks in the list, so i delete it.
+		clear_rsa_key(nick);
+		return;
+	}
+
+	for (temp_nick = temp->nick_list; temp_nick;
+		temp_nick = temp_nick->next)
+	{
+		if (!strcmp(temp_nick->nick, nick))
+			break;
+		old_temp_nick = temp_nick;
+	}
+
+	if (temp_nick == temp->nick_list)
+		temp->nick_list = temp_nick->next;
+	else
+		old_temp_nick->next = temp_nick->next;
+
+	new_free(&(temp_nick->nick));
+	new_free(&temp_nick);
+	c_say(nick, "Nick cell for %s deleted !", nick);
+
+	return;
+}
+
+/*
+ * clean a key
+ */
+void clear_rsa_key (char *nick)
+{
+	struct st_nick_crypted *temp, *oldtemp = NULL;
+	struct st_a_nick       *temp_nick, *oldtemp_nick;
+
+	if (!nick)
+	{
+		c_say(NULL, "No nick given");
+		return;
+	}
+
+	if (!get_rsa_key_from_nick (nick))
+	{
+		c_say(NULL, "No nick found.");
+		return;
+	}
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			if (!strcmp(temp_nick->nick, nick))
+				break;
+
+		if (temp_nick)
+			if (!strcmp(temp_nick->nick, nick))
+				break;
+
+		oldtemp = temp;
+	}
+
+	// nous devrions avoir temp == ce qu'il faut effacer.
+
+	if (temp)
+	{
+		RSA_free(temp->hispubkey);
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			new_free(&(temp_nick->nick));
+
+		for (temp_nick = temp->nick_list; temp_nick;)
+		{
+			oldtemp_nick = temp_nick->next;
+			new_free(&temp_nick);
+			temp_nick = oldtemp_nick;
+		}
+	
+		if (nick_head == temp)
+			nick_head = temp->next;
+		else
+			oldtemp->next = temp->next;
+
+		new_free(&temp);
+		c_say(nick, "RSA key for %s cleaned.", nick);
+	}
+	else
+		c_say(nick, "Can't clean %s's key (not found ?)", nick);
+
+	return;
+}
+
+void cmd_clear_nick (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *target;
+
+	target = next_arg(args, &args);
+
+	if (target)
+	{
+		clear_nick (target);
+	}
+
+	return ;
+}
+
+void cmd_clear_rsa_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *target;
+
+	target = next_arg(args, &args);
+
+	if (target)
+	{
+		if (get_rsa_key_from_nick(target))
+		{
+			clear_rsa_key(target);	
+		}
+	}
+
+	return ;
+}
+
+/*
+ * List all rsa keys
+ */
+void cmd_rsa_list (char *cmd, char *args, char *subargs, char *helparg)
+{
+
+	struct st_nick_crypted *temp;
+	unsigned char *tempkey;
+
+	if (!nick_head)
+	{
+		c_say(NULL, "No rsa keys found.");
+		return ;
+	}
+
+	c_say(NULL, "Nicks you got a rsa key:");
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		tempkey = BN_bn2hex((temp->hispubkey)->n);
+		c_say(NULL, "--[ %s (key: %.8X) %s", 
+			temp->nick_list->nick, my_cksum(tempkey, strlen(tempkey)),
+			(temp->opt & 1)?"THIS KEY IS TRUSTED":"");
+	}
+}
+
+unsigned char *normal_2_irc (unsigned char *texte, int len)
+{
+	int i, j;
+	unsigned char *irced;
+
+	irced = new_malloc(428 + 6 + sizeof(struct st_msg_header));
+
+//	c_say("DEBUG: taille à transformer: %i", len);
+
+	for (i = 0, j = 0; i < len; i ++)
+	{
+		switch (texte[i])
+		{
+			case 0x00: irced[j] = 0x02; irced[j + 1] = 0x04; break;
+			case 0x01: irced[j] = 0x02; irced[j + 1] = 0x05; break;
+			case 0x02: irced[j] = 0x02; irced[j + 1] = 0x06; break;
+			case 0x03: irced[j] = 0x02; irced[j + 1] = 0x07; break;
+			case 0x0A: irced[j] = 0x02; irced[j + 1] = 0x08; break;
+			case 0x0D: irced[j] = 0x02; irced[j + 1] = 0x09; break;
+			default:   irced[j] = texte[i]; j --; break;
+		}
+		j += 2;
+	}
+	irced[j] = 0;
+//	c_say("DEBUG: normal_2_irc: %i to %i (%i)", len, j, j - len);
+	return (irced);
+}
+
+unsigned char *irc_2_normal (unsigned char *texte)
+{
+	int i, j, len;
+	unsigned char *normaltext;
+
+	len = strlen(texte);
+	normaltext = new_malloc(len);
+
+//	c_say("DEBUG: taille à transformer: %i", len);
+
+	for (i = 0, j = 0; i < len; i ++, j ++)
+	{
+		switch(texte[i])
+		{
+			case 0x02:
+			i ++;
+			switch (texte[i])
+			{
+			case 0x04: normaltext[j] = 0x00; break;
+			case 0x05: normaltext[j] = 0x01; break;
+			case 0x06: normaltext[j] = 0x02; break;
+			case 0x07: normaltext[j] = 0x03; break;
+			case 0x08: normaltext[j] = 0x0A; break;
+			case 0x09: normaltext[j] = 0x0D; break;
+			}
+			break;
+
+			default:
+			normaltext[j] = texte[i];
+			break;
+		}
+	}
+//	c_say("DEBUG: irc_2_normal: %i to %i (%i)", len, j, len - j);
+	return(normaltext);
+}
+
+int is_sed_crypted (unsigned char *texte)
+{
+	if (!strncmp((texte + 1), "SED", 3) && *texte == CTCP_DELIM_CHAR)
+		return 1;
+//	c_say("==> %i %i %i", texte[0], *(texte + 1), *(texte + 2));
+	return 0; 
+}
+
+int is_correct_crypt (unsigned char *texte)
+{
+	struct st_msg_header *st;
+	int typ;
+
+	if (is_sed_crypted(texte))
+	{
+		st = get_st(texte);
+		if (st->padding == 0xE347)
+		{
+			typ = st->crypt_method;
+			new_free(&st);
+			return typ; 
+		}
+		c_say(NULL, "padding error");
+		new_free(&st);
+	}
+
+	return 0;
+}
+
+struct st_msg_header *get_st (unsigned char *texte)
+{
+	struct st_msg_header *r_st;
+	int i, j;
+	unsigned char *txt;
+
+	r_st = new_malloc(sizeof(struct st_msg_header));
+	txt = new_malloc(sizeof(struct st_msg_header));
+
+	for (i = 5, j = 0; j < sizeof(struct st_msg_header); i ++, j ++)
+	{
+		switch(texte[i])
+		{
+			case 0x02:
+			i ++;
+			switch (texte[i])
+			{
+	 			case 0x04: txt[j] = 0x00; break;
+				case 0x05: txt[j] = 0x01; break;
+				case 0x06: txt[j] = 0x02; break;
+				case 0x07: txt[j] = 0x03; break;
+				case 0x08: txt[j] = 0x0A; break;
+				case 0x09: txt[j] = 0x0D; break;
+			}
+			break;
+
+			default:
+				txt[j] = texte[i];
+			break;
+		}
+	}
+
+	memcpy(r_st, txt, sizeof(struct st_msg_header));
+	new_free(&txt);
+	return(r_st);
+}
+
+unsigned char *form_normal_irc
+	(unsigned char *texte, short cr_len, short un_len, int typ)
+{
+	unsigned char *ftexte, *final, *realend;
+	struct st_msg_header *st;
+
+	st = new_malloc (sizeof(struct st_msg_header));
+
+	st->cr_len = cr_len;
+	st->un_len = un_len;
+	st->crc32  = my_cksum (texte, st->cr_len);
+//	c_say("st->crc32 = %.8X (%s, %i)", st->crc32, texte, st->cr_len);
+	st->crypt_method = typ;
+	st->opt    = 0;
+	st->padding = 0xE347;
+	st->text   = 0;
+
+	realend = new_malloc (428 + sizeof(struct st_msg_header));
+
+	ftexte = new_malloc (428 + sizeof(struct st_msg_header));
+	bzero (ftexte, 428 + sizeof(struct st_msg_header));
+
+	memcpy (ftexte, st, sizeof(struct st_msg_header));
+	memcpy (ftexte + sizeof(struct st_msg_header), texte, cr_len);
+
+	final = normal_2_irc (ftexte, cr_len + sizeof(struct st_msg_header));
+
+	sprintf(realend, "%cSED %s%c%c", CTCP_DELIM_CHAR, final, CTCP_DELIM_CHAR, 0);
+//	c_say("DEBUG: taille du message: %i", strlen(realend));
+
+	new_free(&st);
+	new_free(&final);
+	new_free(&ftexte);
+
+	return (realend);
+}
+
+struct st_msg_header *form_irc_normal (unsigned char *texte)
+{
+	unsigned char *int_texte;
+	struct st_msg_header *st;
+
+	int_texte = irc_2_normal (texte);
+
+	st = new_malloc(sizeof(struct st_msg_header));
+
+	memcpy(st, int_texte + 5, sizeof(struct st_msg_header));
+
+	st->text = new_malloc(st->cr_len);
+	bzero(st->text, st->cr_len);
+
+	memcpy(st->text, int_texte + 5 + sizeof(struct st_msg_header), st->cr_len);
+
+	return st;
+}
+
+unsigned char *cns_crypt_RSA (unsigned char *phrase, RSA *key, int p_len)
+{
+	unsigned char *crypted, *final;
+	int len, i, j, cr_len;
+
+	if (!p_len)
+		len = strlen(phrase);
+	else
+		len = p_len;
+
+	len = (len>351)?351:len;
+
+	crypted = new_malloc (sizeof(char) * 384);
+	bzero (crypted, 384);
+
+	for (i = 0, j = 0, cr_len = 0; i < len; 
+		i += (RSA_CRLEN - 11), j += RSA_CRLEN)
+	{
+		if ((cr_len += RSA_public_encrypt(RSA_CRLEN - 11, 
+			(phrase + i), (crypted + j), key, RSA_PKCS1_PADDING)) == -1 )
+		{
+			c_say(NULL, "RSA_public_encrypt error");
+			cr_len ++; // -1 + 1 = 0
+		}
+	}
+	final = form_normal_irc (crypted, cr_len, i, RSA_CRYPT);
+
+	new_free(&crypted);
+	return (final);
+}
+
+unsigned char *cns_decrypt_RSA (unsigned char *phrase)
+{
+	int i, j;
+	struct st_msg_header *st;
+	unsigned char *uncrypted;
+
+	uncrypted = new_malloc (sizeof(char) * 384);
+	st = form_irc_normal(phrase);
+	
+	for (i = 0, j = 0; i < st->cr_len; i += RSA_CRLEN, j += (RSA_CRLEN - 11))
+	{
+//		c_say("decrypt: writing %i->%i to %i->%i", 
+//			i, i + RSA_CRLEN, j, j + RSA_CRLEN - 11);
+
+		if(RSA_private_decrypt(RSA_CRLEN, (st->text + i), (uncrypted + j),
+			my_priv_key, RSA_PKCS1_PADDING) == -1 )
+		{
+//			c_say(NULL, "RSA_private_decrypt error");
+		}
+	} 
+
+	uncrypted[j] = 0x00;
+	new_free(&(st->text));
+	new_free(&st);
+
+	return (uncrypted);
+}
+
+unsigned char *cns_crypt_twofish (unsigned char *phrase, unsigned char *key)
+{
+	int len, t_len, i, my_len;
+	unsigned char *crypted, *tmptxt;
+
+	my_len = strlen(phrase);
+	len = my_len;
+	len = (len>384)?384:len;
+
+	t_len = (!(len%16))?len:(len + ( 16 - (len % 16) ));
+
+	tmptxt = new_malloc (t_len);
+	bzero (tmptxt, t_len);
+	strncpy(tmptxt, phrase, len);
+
+	crypted = new_malloc (t_len);
+	bzero (crypted, t_len);
+
+	set_key_twofish((const u4byte*)key, 256);
+
+	for (i = 0; i < t_len; i += 16)
+	{
+		encrypt_twofish ((const u4byte*)(tmptxt + i), (u4byte*)(crypted + i));
+	}
+	
+	new_free(&tmptxt);
+
+	tmptxt = form_normal_irc (crypted, t_len, len, TWOFISH_CRYPT);
+
+	new_free(&crypted);
+	return (tmptxt);
+}
+
+unsigned char *cns_decrypt_twofish (unsigned char *phrase, unsigned char *key)
+{
+	struct st_msg_header *st;
+	unsigned char *uncr;
+	int i;
+
+	st = form_irc_normal (phrase);
+//	c_say("using cns_decrypt_twofish: st->cr_len= %i, st->crc32= %.8X, cksum: %.8X", st->cr_len, st->crc32, my_cksum (st->text, st->cr_len));
+
+	if ((st->cr_len % 16) || (st->cr_len > 384))
+	{
+		// returns [CRYPT ERROR]
+		uncr = new_malloc(16);
+		strcpy(uncr, "[CRYPT ERROR]");
+	}	
+	else if (st->crc32 != my_cksum (st->text, st->cr_len))
+	{
+		uncr = new_malloc(16);
+		strcpy(uncr, "[CRYPT ERROR]");	
+	} 
+	else
+	{
+		uncr = new_malloc(st->cr_len);
+		set_key_twofish((const u4byte*)key, 256);
+
+		for (i = 0; i < st->cr_len; i += 16)
+		{
+			decrypt_twofish ((const u4byte*)(st->text + i), (u4byte*)(uncr + i));
+		}
+	}
+
+	if (strlen(uncr) != st->un_len)
+	{
+		new_free(&uncr);
+		uncr = new_malloc(16);
+		strcpy(uncr, "[CRYPT ERROR]");
+	}
+
+	new_free(&(st->text));
+	new_free(&st);
+	return (uncr);
+
+}
+
+void cmd_test_rsa_crypt (char *cmd, char *args, char *subargs, char *helparg)
+{ 
+	struct st_msg_header *final_struct;
+	unsigned char *test_string, *int_string;
+	unsigned char *final, *test;
+	RSA *temp_pub_key;
+
+	test_string = new_malloc(256);
+	memset(test_string, '&', 255);
+	test_string[255] = 0;
+
+	int_string = form_normal_irc(test_string, 256, 256, RSA_CRYPT);
+	final_struct = form_irc_normal(int_string);
+
+//	c_say("=> %s (%i)", test_string, strlen(test_string));
+//	c_say("=> %s (%i)", final_struct->text, strlen(final_struct->text));
+
+	if (!strcmp(final_struct->text, test_string))
+		c_say(NULL, "first step: ok it's working.");	
+	else
+		c_say(NULL, "first step: no, it is not working.");
+
+	temp_pub_key = RSA_new();
+	temp_pub_key->n = BN_dup(my_priv_key->n);
+	temp_pub_key->e = BN_dup(my_priv_key->e);
+
+	test = cns_crypt_RSA(test_string, temp_pub_key, 0);
+	final = cns_decrypt_RSA(test);
+
+	if (!strcmp(final, test_string))
+		c_say(NULL, "second step: RSA crypt is ok !");
+	else
+		c_say(NULL, "second step: RSA crypt is not ok ... :( [%s]", final);
+	
+	new_free(&final);
+	new_free(&test);
+	RSA_free(temp_pub_key);
+	new_free(&(final_struct->text));
+	new_free(&final_struct);
+	new_free(&int_string);
+	new_free(&test_string);
+}
+
+int is_crypted_by_opt (unsigned char *target)
+{
+	struct st_chan_crypted *temp;
+	
+	if (!target)
+		return 1;
+
+	for (temp = chan_head; temp; temp = temp->next)
+	{
+		if (!strcmp(temp->chan, target))
+		{
+			if (temp->opt & 1)
+				return 0;
+		}
+	}
+
+	return 1;
+
+}
+
+int is_cnsirc_crypted (unsigned char *target, unsigned char *command)
+{
+	if (get_pass_from_chan(target))
+	{
+		if (command != NULL)
+			if (!strcmp(command, "Crypt Message"))
+				return TWOFISH_CRYPT;
+
+		if (!is_crypted_by_opt(target))
+			return 0;
+		else
+			return TWOFISH_CRYPT;
+	}
+
+	if (get_rsa_key_from_nick(target))
+		return RSA_CRYPT;
+
+	return 0;
+}
+
+int is_have_to_send_clear_text (char *cmd)
+{
+	if (cmd)
+		if (!strcmp(cmd, "Clear Message"))
+			return 1;
+
+	return 0;
+}
+
+// XXX: to code:
+unsigned char *get_pass_from_chan (char *chan)
+{
+	struct st_chan_crypted *temp;
+
+	for (temp = chan_head; temp; temp = temp->next)
+		if (!strcasecmp(chan, temp->chan))
+			return temp->chankey;
+
+	return NULL;
+}
+
+struct st_chan_crypted *add_chan_key (char *channel, unsigned char *chankey)
+{
+	struct st_chan_crypted *temp;
+
+	temp = new_malloc (sizeof(struct st_chan_crypted));
+	temp->chan = new_malloc(strlen(channel));
+	strcpy(temp->chan, channel);
+	temp->chankey = chankey;
+	temp->next = chan_head;
+	temp->crypt_typ = TWOFISH_CRYPT;
+	chan_head = temp;
+
+	return temp;
+}
+
+void cmd_gen_chan_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	struct st_chan_crypted *temp;
+	char *channel;
+	// creating new chan
+
+	if (!(channel = next_arg(args, &args)))
+		channel = get_current_channel_by_refnum(0);
+
+	if (!channel)
+	{
+		c_say(NULL, "You're not on a channel !");
+		return;
+	}	
+
+	if (!get_pass_from_chan(channel))
+	{
+		temp = add_chan_key(channel, cns_generate_channel_key());
+		c_say(channel, "%s is now crypted ... (key crc: %.8X)",
+			channel, my_cksum(temp->chankey, 32));
+	}
+	else
+	{
+		c_say(NULL, "This channel is already crypted.");
+		return ;
+	}
+
+	return ;
+}
+
+
+/*
+ * List all channels: XXX
+ */ 
+void cmd_chan_list (char *cmd, char *args, char *subargs, char *helparg)
+{
+	struct st_chan_crypted *temp;
+
+	for (temp = chan_head; temp; temp = temp->next)
+	{
+		c_say(NULL, "--[ %s (key: %.8X)", temp->chan, my_cksum(temp->chankey, 32));
+	}
+
+	return ;
+}
+
+void cmd_free_chan (char *channel)
+{
+	struct st_chan_crypted *temp, *oldtemp = NULL;
+
+	if (!channel)
+	{
+		c_say(NULL, "No channel to remove the key");
+		return;
+	}
+
+	for (temp = chan_head; temp; temp = temp->next)
+	{
+		if (!strcmp(temp->chan, channel))
+		{
+		if (temp == chan_head)
+			chan_head = temp->next;
+		else
+			oldtemp->next = temp->next;
+
+		new_free(&(temp->chan));
+		new_free(&(temp->chankey));
+		new_free(&temp);
+//		c_say(channel, "No more encryption for %s.", channel);
+		break;
+		}
+
+		oldtemp = temp;
+	} 
+
+	if (temp)
+	{
+//		c_say(channel, "No encryption for %s.", channel);
+	}
+
+	return ;
+}
+
+void cmd_clear_chan_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *channel;
+
+	if (!(channel = next_arg(args, &args)))
+		channel = get_current_channel_by_refnum(0);
+
+	if (channel)
+		cmd_free_chan (channel);
+	else
+	{
+		c_say(NULL, "No channel to remove the key");
+		return;
+	}
+
+	return;
+}
+
+void cmd_clear_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	cmd_clear_chan_key (cmd, args, subargs, helparg);
+	cmd_clear_rsa_key  (cmd, args, subargs, helparg);
+	return ;
+}
+
+void send_chan_key (char *nick, char *channel)
+{
+	unsigned char *t_send, *text, *chankey;
+	RSA *key;
+
+	if (!(chankey = get_pass_from_chan(channel)))
+	{
+		// creating a key:
+		cmd_gen_chan_key(NULL, NULL, NULL, NULL);
+	}
+
+	if (!(key = get_rsa_key_from_nick(nick)))
+	{
+		c_say(nick, "No RSA key for %s ! Can't send %s's key !", nick, channel); 
+		return ;
+	}
+
+	// we'll send this string:
+	// <CNSkey>XchanCHANKEY
+	// where X = strlen(chan); strlen(CHANKEY) == 32;
+
+	if ((t_send = new_malloc(41 + strlen(channel))))
+	{
+		sprintf (t_send, "<CNSkey>%c%s", strlen(channel), channel);
+		memcpy ((t_send + 9 + strlen(channel)), chankey, 32);
+
+		text = cns_crypt_RSA (t_send, key, 41 + strlen(channel));
+
+		send_to_server("PRIVMSG %s :%s", nick, text);
+
+		c_say(nick, "%s's key sent to %s", channel, nick);
+		new_free(&text);
+		new_free(&t_send);
+	}
+	return; 
+}
+
+void cmd_send_chan_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+	unsigned char *chan, *nick;
+
+	nick = next_arg(args, &args);
+	chan = next_arg(args, &args);
+
+	if (!nick)
+		nick = last_nick;
+	if (!chan)
+		chan = last_chan;
+	if (!chan)
+		chan = get_current_channel_by_refnum(0); 
+
+	if (!chan || !nick)
+	{
+		c_say(NULL, "Not enought arguments for /csendkey");
+		return ;
+	}
+	else
+		send_chan_key (nick, chan);
+
+	last_chan = NULL;
+	last_nick = NULL;
+	
+	return ;
+}
+
+int recieve_chan_key (char *phrase, int p_len)
+{
+	int len;
+	unsigned char *chan;
+	unsigned char *key;
+
+	if (!phrase)
+	{
+		return 0;
+	}
+
+	if (p_len < 41)
+	{	
+		return 0;
+	}
+
+	if (!strncmp("<CNSkey>", phrase, 8))
+	{
+		len = phrase[8];		
+		chan = new_malloc(len + 1);
+		key = new_malloc(32);
+		bzero(chan, len + 1);
+		strncpy(chan, (phrase + 9), len);
+		memcpy(key, (phrase + 9 + len), 32);
+		c_say(NULL, "Recieved key for %s.", chan, len);	
+		if (get_pass_from_chan(chan))
+		{
+			c_say(NULL, "Recieved key for an existing %s - deleting it.", chan);
+			cmd_free_chan (chan);
+		}
+		add_chan_key (chan, key);
+		return 1;
+	}
+	return 0;
+}
+
+void cmd_clear_text (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *channel;
+
+	if ((channel = get_current_channel_by_refnum(0)))
+	{
+		send_text (channel, args, cmd, window_display, 1);
+	}
+}
+
+void c_rename_nick (char *from_nick, char *to_nick)
+{
+	struct st_nick_crypted 	*temp;
+	struct st_a_nick		*temp_nick, *new_temp_nick = NULL;
+
+	if (!from_nick || !to_nick)
+		return ;
+
+	if (get_rsa_key_from_nick(to_nick) 
+		|| !get_rsa_key_from_nick(from_nick))
+	{
+		// this key already exists.
+		return ;
+	}
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			if (!strcmp(temp_nick->nick, from_nick))
+				break;
+
+		if (temp_nick)
+			if (!strcmp(temp_nick->nick, from_nick))
+				break;
+	}
+
+	new_temp_nick = new_malloc(sizeof(struct st_a_nick));
+	new_temp_nick->nick = new_malloc(32);
+	strncpy(new_temp_nick->nick, to_nick, 
+		(strlen(to_nick)>32)?32:strlen(to_nick));
+	new_temp_nick->next = temp->nick_list;
+	temp->nick_list = new_temp_nick;
+
+	return ;
+
+}
+
+void cmd_list_all_nick (char *cmd, char *args, char *subargs, char *helparg)
+{
+	struct st_nick_crypted	*temp;
+	struct st_a_nick		*temp_nick;
+	unsigned long crc32;
+	unsigned char *rsakey;
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		rsakey = BN_bn2hex(temp->hispubkey->n);
+		crc32 = my_cksum(rsakey, 32);
+		c_say(NULL, "-[ key: %.8X for:", crc32);
+
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			c_say(NULL, "--[ %s", temp_nick->nick);
+	}
+}
+
+void cmd_ctoggle (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *channel;
+	struct st_chan_crypted *temp;
+
+	if (!(channel = next_arg(args, &args)))
+		channel = get_current_channel_by_refnum(0); 
+
+	if (!channel)
+	{
+		c_say(NULL, "You're not in a channel.");
+		return;
+	}
+
+	if (!get_pass_from_chan(channel))
+	{
+		c_say(channel, "This channel (%s) is not crypted.", channel);
+		return;
+	}	
+
+	for (temp = chan_head; temp; temp = temp->next)
+	{
+		if (!strcmp(temp->chan, channel))
+		{
+			if (temp->opt)
+			{
+				c_say(channel,"This channel (%s) is now crypted by default.", channel);
+				temp->opt ^= 1;
+			}
+			else
+			{
+				c_say(channel, "This channel (%s) is no more crypted.", channel); 
+				temp->opt ^= 1;
+			}
+		}
+	} 
+
+	return ;
+}
+
+void cmd_trust (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *nick;
+	struct st_nick_crypted 	*temp;
+	struct st_a_nick		*temp_nick;
+	unsigned long crc32;
+
+	if (!(nick = next_arg(args, &args)))
+	{
+		c_say(NULL, "Please give at least a nick name ...");
+		return;
+	}
+
+	if (!get_rsa_key_from_nick(nick))
+	{
+		c_say(NULL, "Can't trust %s.", nick);
+		return;
+	}
+
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			if (!strcmp(nick, temp_nick->nick))
+			{
+				temp->opt = 1;
+				crc32 = my_cksum(BN_bn2hex(temp->hispubkey->n), 32);
+				c_say(NULL, "NICK: %s (RSA: %.8X) is now TRUSTED.", 
+					nick, crc32);
+				return;
+			}
+	}
+	return;
+}
+
+void cmd_untrust (char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *nick;
+	struct st_nick_crypted	*temp;
+	struct st_a_nick		*temp_nick;
+
+	if (!(nick = next_arg(args, &args)))
+	{
+		c_say(NULL, "Please give at least a nick name ...");
+		return;
+	}
+
+	if (!get_rsa_key_from_nick(nick))
+	{
+		c_say(NULL, "Can't un-trust %s.", nick);
+		return;
+	}
+
+	for (temp = nick_head; temp; temp = temp->next)
+	{
+		for (temp_nick = temp->nick_list; temp_nick;
+			temp_nick = temp_nick->next)
+			if (!strcmp(nick, temp_nick->nick))
+			{
+				if (temp->opt & 1)
+				{
+					temp->opt --;
+					c_say(NULL, "%s is no more trusted.", nick);
+				}
+			}
+	}
+	
+}
+
+void cmd_require_key (char *cmd, char *args, char *subargs, char *helparg)
+{
+
+	char *nick, *channel;
+
+	if (!(nick = next_arg(args, &args)))
+	{
+		c_say(NULL, "You need to specify a target nick for key requiring");
+		return;
+	}
+
+	if (!(channel = next_arg(args, &args)))
+		channel = get_current_channel_by_refnum(0);
+
+	if (!channel)
+	{
+		c_say(NULL, "You're not in a channel !");
+		return;
+	}
+
+	c_say(nick, "Requiring %s's key from %s", channel, nick);
+
+	send_ctcp (CTCP_PRIVMSG, nick, CTCP_CNS_CMD, "GET_KEY %s", channel);
+
+	return ;
+}
+
+void cmd_require_rsa_key 
+	(char *cmd, char *args, char *subargs, char *helparg)
+{
+	char *nick;
+
+	if (!(nick = next_arg(args, &args)))
+	{
+		c_say(NULL, "You need to specify a target nick for key requiring");
+		return;
+	}
+
+	c_say(nick, "Requiring %s's key.", nick);
+	send_ctcp (CTCP_PRIVMSG, nick, CTCP_CNS_CMD, "GET_RSA");
+
+	return ;
+}
+
+void get_ctcp_cnscmd(char *from, char *to, char *message)
+{
+	char *command, *chan;
+	char *temptext, *inte, *text;
+	unsigned long crc;
+//	c_say("hum, something said: hurry up cnscmd(%s) !",message);
+
+	if (get_int_var(IGNORE_REMOTE_VAR))
+		return;
+
+	command = next_arg(message, &message);
+
+	if (!strncmp(command, "GET_KEY", strlen("GET_KEY")))
+	{
+		chan = next_arg(message, &message);	
+		if (!chan)
+		{
+			c_say(from, "Recieved a GET_KEY from %s of nothing.", from);
+			return;
+		}
+
+		if (is_trusted_nick (from))
+		{
+			c_say(from, "Granted send of %s's channel key for %s.", chan, from);
+			send_chan_key (from, chan);
+			return;
+		}
+		else
+		{
+			c_say(from, "Recieved a GET_KEY from an untrusted nick %s.", from);
+			return;
+		}
+
+		// is trusted ? :)
+	}	
+
+	if (!strncmp(command, "GET_RSA", strlen("GET_RSA")))
+	{
+	// someone wants my RSA key ? ok, let's give it :-)
+		if (!my_priv_key)
+		{
+			return ;
+		}
+		c_say(from, "%s requiered your rsa key.", from);
+
+		temptext = BN_bn2hex(my_priv_key->n);
+		if ((inte = encode_rsa_key(temptext)) != NULL)
+		{
+			text = new_malloc(512);
+			crc = my_cksum(inte, strlen(inte));
+			sprintf(text, "<CNSirc>%s %.8x", inte, (unsigned int)crc);
+			send_text(from, text, "Clear Message", window_display, 1);
+			new_free(&inte);
+		}
+
+		return;
+	}
+
+	c_say(NULL, "Recieved unknowm command (%s).", command);
+	return ;
+}
+
+void cmd_greet (char *cmd, char *args, char *subargs, char *helparg)
+{
+	c_say(NULL, "CNSirc greets:");
+	c_say(NULL, "--[ There is no greet ... we re anonymous, you remember, don't you ?");
+	c_say(NULL, "--[ I thank all CNS/Minithins staff ... for all we do !");	
+	c_say(NULL, "--[ I thank an old teacher, and finaly mux :)");
+}
+
+void cmd_key_save (char *cmd, char *args, char *subargs, char *helparg)
+{
+	save_private_file();
+}
+
+void cmd_key_load (char *cmd, char *args, char *subargs, char *helparg)
+{
+	load_private_file();
+}
+
+void clear_all_keys()
+{
+	struct st_a_nick *temp_sub_nick, *old_temp_sub_nick;
+	struct st_nick_crypted *temp_nick, *old_temp_nick;
+	struct st_chan_crypted *temp_chan, *old_temp_chan;
+
+	for (temp_chan = chan_head; temp_chan;)
+	{
+		old_temp_chan = temp_chan->next;
+		new_free(&(temp_chan->chan));
+		new_free(&(temp_chan->chankey));
+		new_free(&temp_chan);
+		temp_chan = old_temp_chan;
+	}
+
+	temp_chan = NULL;
+
+	for (temp_nick = nick_head; temp_nick;)
+	{
+		old_temp_nick = temp_nick->next;
+
+		for (temp_sub_nick = temp_nick->nick_list; temp_sub_nick;)
+		{
+			old_temp_sub_nick = temp_sub_nick->next;
+			new_free(&(temp_sub_nick->nick));
+			new_free(&temp_sub_nick);
+			temp_sub_nick = old_temp_sub_nick;
+		}
+
+		//new_free(&(temp_nick->hispubkey));
+		RSA_free(temp_nick->hispubkey);
+		new_free(&temp_nick);
+		temp_nick = old_temp_nick;
+	}
+
+	temp_nick = NULL;
+
+	chan_head = NULL;
+	nick_head = NULL;
+
+	new_free(&last_chan);
+	last_chan = NULL;
+	new_free(&last_nick);
+	last_nick = NULL;
+
+	return ;
+}
+
+void load_private_file()
+{
+	char filename[1024];
+	unsigned char *new_chan_key, *new_channel, *new_nick, *read_nick;
+	unsigned char crp;
+	int fd_file, len, i;
+
+	c_say(NULL, "Clearing keys before loading ...");
+	clear_all_keys();
+
+	c_say(NULL,"Loading -private- keys ...");
+
+	sprintf (filename, "%s/.BitchX/CNSkeys/CNSirc.data", getenv("HOME"));
+
+	fd_file = open (filename, O_RDONLY, 0600); 
+
+	if (fd_file == -1)
+	{
+		c_say(NULL, "CNSirc.data can't be find/opened. I don't care");
+		return ;
+	}
+
+	while ((i = read (fd_file, &crp, 1)))
+	{
+		if (crp == 254)
+		{
+			read (fd_file, &len, sizeof(size_t));	
+
+			new_channel = new_malloc(len);	
+			read (fd_file, new_channel, len);
+			new_channel[len] = 0;
+
+			new_chan_key = new_malloc(32);
+			i = read (fd_file, new_chan_key, 32);
+			c_say(NULL, "--[ added channel %s (key: %.8X)", 
+				new_channel, my_cksum(new_chan_key, 32));
+			add_chan_key (new_channel, new_chan_key);
+
+			new_free(&new_channel);
+		} 
+		else if (crp == 126)
+		{
+			read (fd_file, &len, sizeof(size_t));
+
+			new_channel = new_malloc(len);
+			i = read (fd_file, new_channel, len);
+
+			read (fd_file, &len, sizeof(size_t)); 
+			new_nick = new_malloc(len);
+			
+			read (fd_file, new_nick, len);
+
+			add_rsa_key (new_nick, new_channel);
+			do
+			{
+				read (fd_file, &len, sizeof(size_t));
+				if (len != 0)
+				{
+					read_nick = new_malloc(len);
+					i = read (fd_file, read_nick, len);
+					c_rename_nick (new_nick, read_nick);
+					new_free(&read_nick);
+				}
+			}
+			while (len != 0);
+
+			new_free(&new_nick);
+			new_free(&new_channel);
+		}
+	}
+	
+	c_say(NULL, "End of loading keys ...");
+	close (fd_file);
+}
+
+void save_private_file()
+{
+	struct st_a_nick *temp_sub_nick;
+	struct st_nick_crypted *temp_nick;
+	struct st_chan_crypted *temp_chan;
+	unsigned char *the_key;
+	char filename[1024];
+	unsigned char crp;
+	int fd_file, len;
+
+	c_say(NULL, "Saving keys ...");
+	c_say(NULL, "WARNING: Saving private keys may be dangerous. Please don't use");
+
+	sprintf(filename, "%s/.BitchX/CNSkeys/CNSirc.data", getenv("HOME"));
+
+	fd_file = open (filename, O_CREAT | O_TRUNC | O_WRONLY, 0600);
+
+	for (temp_chan = chan_head; temp_chan;
+		temp_chan = temp_chan->next)
+	{
+		crp = 254;
+		write (fd_file, &crp, 1);
+
+		len = strlen(temp_chan->chan);
+		write (fd_file, &len, sizeof(size_t));
+		write (fd_file, temp_chan->chan, len);
+		write (fd_file, temp_chan->chankey, 32);
+	}
+
+	for (temp_nick = nick_head; temp_nick;
+		temp_nick = temp_nick->next)
+	{
+		crp = 126;
+		write (fd_file, &crp, 1);
+		the_key = BN_bn2hex(temp_nick->hispubkey->n);
+		len = strlen(the_key);
+		write (fd_file, &len, sizeof(size_t));
+		write (fd_file, the_key, len); 
+
+		for (temp_sub_nick = temp_nick->nick_list; temp_sub_nick;
+			temp_sub_nick = temp_sub_nick->next)
+		{
+			len = strlen(temp_sub_nick->nick);
+			write (fd_file, &len, sizeof(size_t));
+			write (fd_file, temp_sub_nick->nick, len);
+		}
+		len = 0;
+		write (fd_file, &len, sizeof(size_t));
+	}
+
+	close (fd_file);
+
+	c_say(NULL, "End of saving keys ...");
+
+	return ;
+}
